<?php
class ChatButton
{
	protected static $instance;
	protected $persistHooks = FALSE;
	
	public static function getInstance()
	{
		$subClass = get_class();
		if (null == self::$instance){
			self::$instance = new $subClass;
		}
		return self::$instance;
	}
	/**
	 * Setup the object, gather all of the relevant settings
	 */
	protected function __construct(){
		$this->hooks = array('integrate_menu_buttons',	'integrate_actions',);
		if (!$this->persistHooks){
			foreach ($this->hooks as $hook)
				add_integration_function($hook, get_class($this) . '::handleHook', $this->persistHooks);
		}			
	}
	protected function integrate_menu_buttons(&$menu_buttons)
	{
		global $context,$scripturl;
		$position = 1;
		$menu_insert_buttons['chatmanagement'] = array(
			'title' => "Chat Management",
			'target' => '_blank',
			'href' => $scripturl . '?action=chatmanagement',
			'show' => allowedTo('admin_forum'),

			'sub_buttons' =>  array(
				'chatmanagement' => array(
				'title' => "Chat Management",
				'target' => '_blank',
				'href' => $scripturl . '?action=chatmanagement',
				'show' => allowedTo('admin_forum'),
				),
			'chatadmin' => array(
				'title' => "Chat Admin Panel",
				'target' => '_blank',
				'href' => $scripturl . '?action=chatadminpanel',
				'show' => allowedTo('admin_forum'),
				),
			),
		);		
		$menu_insert_buttons['chat'] = array(
			'title' => 'Chat',
			'target' => '_blank',
			'href' => $scripturl . '?action=chat',
			'is_last' => !$context['right_to_left'],
			'show' => true,			
		);
		$menu_buttons = array_merge($menu_buttons, $menu_insert_buttons, array_splice($menu_buttons, $position));
		//$menu_buttons = $this->insert_menu_buttons_position($menu_buttons, $menu_insert_buttons, $position);
		// Need to set the previous last button to not be last
		//$menu_buttons[$user_info['is_guest'] ? 'register' : 'logout']['is_last'] = FALSE;
	}
	
	/*protected function insert_menu_buttons_position($menu_buttons, $menu_insert_buttons, $position)
	{
		$postArray = array_splice($menu_buttons, $position);
		return array_merge($menu_buttons, $menu_insert_buttons, $postArray);
	}*/
	
	protected function integrate_actions(&$actionArray)
	{
		global $context, $user_info;
		$actionArray['chat'] = array('Chat.php', 'ChatMain');
		$actionArray['chatmanagement'] = array('ChatAdmin.php', 'ChatSetting');
		$actionArray['chatadminpanel'] = array('ChatAdminPanel.php', 'ChatAdminSetting');
	}
	
	public static function handleHook()
	{
		$backtrace = debug_backtrace();
		$method = NULL;
		$args = NULL;
		foreach ($backtrace as $item)
			if ($item['function'] === 'call_integration_hook')
			{
				$method = $item['args'][0];
				$args = !empty($item['args'][1]) ? $item['args'][1] : array();
				break;
			}

		if (!isset($method) || !is_callable(array(self::$instance, $method)))
			trigger_error('Invalid call to handleHook', E_USER_ERROR);
		return call_user_func_array(array(self::$instance, $method), $args);
	}
}

ChatButton::getInstance();
